public inbox for gdb-patches@sourceware.org
 help / color / mirror / Atom feed
* [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-06 17:56 [PATCH v2 0/3] Update FreeBSD's syscall table John Baldwin
  2018-11-06 17:56 ` [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group John Baldwin
@ 2018-11-06 17:56 ` John Baldwin
  2018-11-09  4:34   ` Kevin Buettner
                     ` (2 more replies)
  2018-11-06 17:56 ` [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0 John Baldwin
  2018-11-06 18:49 ` [PATCH v2 0/3] Update FreeBSD's syscall table Sergio Durigan Junior
  3 siblings, 3 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-06 17:56 UTC (permalink / raw)
  To: gdb-patches

When setting a syscall catchpoint by name, catch syscalls whose name
or alias matches the requested string.

When the ABI of a system call is changed in the FreeBSD kernel, this
is implemented by leaving a compatibility system call using the old
ABI at the existing "slot" and allocating a new system call for the
version using the new ABI.  For example, new fields were added to the
'struct kevent' used by the kevent() system call in FreeBSD 12.  The
previous kevent() system call in FreeBSD 12 kernels is now called
freebsd11_kevent() and is still used by older binaries compiled
against the older ABI.  The freebsd11_kevent() system call can be
tagged with an "alias" attribute of "kevent" permitting 'catch syscall
kevent' to catch both system calls and providing the expected user
behavior for both old and new binaries.  It also provides the expected
behavior if GDB is compiled on an older host (such as a FreeBSD 11
host).

gdb/ChangeLog:

	* break-catch-syscall.c (catch_syscall_split_args): Update for
	get_syscalls_by_name returning a vector.
	* gdbarch.sh (UNKNOWN_SYSCALL): Remove.
	* gdbarch.h: Regenerate.
	* syscalls/gdb-syscalls.dtd (syscall): Add alias attribute.
	* xml-syscall.c [!HAVE_LIBEXPAT] (get_syscalls_by_name): Rename
	from get_syscall_by_name.  Now returns a vector of integers.
	[HAVE_LIBEXPAT] (struct syscall_desc): Add alias member.
	(syscall_create_syscall_desc): Add alias parameter and pass it to
	syscall_desc constructor.
	(syscall_start_syscall): Handle alias attribute.
	(syscall_attr): Add alias attribute.
	(xml_get_syscalls_by_name): Rename from xml_get_syscall_number.
	Now returns a vector of integers.  Add syscalls whose alias or
	name matches the requested name.
	(get_syscalls_by_name): Rename from get_syscall_by_name.  Now
	returns a vector of integers.
	* xml-syscall.h (get_syscalls_by_name): Likewise.
---
 gdb/ChangeLog                 | 21 +++++++++++++
 gdb/break-catch-syscall.c     | 11 +++----
 gdb/gdbarch.h                 |  3 --
 gdb/gdbarch.sh                |  3 --
 gdb/syscalls/gdb-syscalls.dtd |  1 +
 gdb/xml-syscall.c             | 55 ++++++++++++++++++-----------------
 gdb/xml-syscall.h             |  9 +++---
 7 files changed, 62 insertions(+), 41 deletions(-)

diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 9f4c450e4e..487c97a957 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,24 @@
+2018-11-06  John Baldwin  <jhb@FreeBSD.org>
+
+	* break-catch-syscall.c (catch_syscall_split_args): Update for
+	get_syscalls_by_name returning a vector.
+	* gdbarch.sh (UNKNOWN_SYSCALL): Remove.
+	* gdbarch.h: Regenerate.
+	* syscalls/gdb-syscalls.dtd (syscall): Add alias attribute.
+	* xml-syscall.c [!HAVE_LIBEXPAT] (get_syscalls_by_name): Rename
+	from get_syscall_by_name.  Now returns a vector of integers.
+	[HAVE_LIBEXPAT] (struct syscall_desc): Add alias member.
+	(syscall_create_syscall_desc): Add alias parameter and pass it to
+	syscall_desc constructor.
+	(syscall_start_syscall): Handle alias attribute.
+	(syscall_attr): Add alias attribute.
+	(xml_get_syscalls_by_name): Rename from xml_get_syscall_number.
+	Now returns a vector of integers.  Add syscalls whose alias or
+	name matches the requested name.
+	(get_syscalls_by_name): Rename from get_syscall_by_name.  Now
+	returns a vector of integers.
+	* xml-syscall.h (get_syscalls_by_name): Likewise.
+
 2018-11-06  John Baldwin  <jhb@FreeBSD.org>
 
 	* break-catch-syscall.c (catch_syscall_split_args): Update for
diff --git a/gdb/break-catch-syscall.c b/gdb/break-catch-syscall.c
index 8e1de10fa7..b6f0978b5d 100644
--- a/gdb/break-catch-syscall.c
+++ b/gdb/break-catch-syscall.c
@@ -425,18 +425,19 @@ catch_syscall_split_args (const char *arg)
 	}
       else
 	{
-	  /* We have a name.  Let's check if it's valid and convert it
-	     to a number.  */
-	  get_syscall_by_name (gdbarch, cur_name, &s);
+	  /* We have a name.  Let's check if it's valid and fetch a
+	     list of matching numbers.  */
+	  std::vector<int> numbers = get_syscalls_by_name (gdbarch, cur_name);
 
-	  if (s.number == UNKNOWN_SYSCALL)
+	  if (numbers.empty ())
 	    /* Here we have to issue an error instead of a warning,
 	       because GDB cannot do anything useful if there's no
 	       syscall number to be caught.  */
 	    error (_("Unknown syscall name '%s'."), cur_name);
 
 	  /* Ok, it's valid.  */
-	  result.push_back (s.number);
+	  for (int number : numbers)
+	    result.push_back (number);
 	}
     }
 
diff --git a/gdb/gdbarch.h b/gdb/gdbarch.h
index 2cb6961083..8e354d2278 100644
--- a/gdb/gdbarch.h
+++ b/gdb/gdbarch.h
@@ -1569,9 +1569,6 @@ typedef ULONGEST (gdbarch_type_align_ftype) (struct gdbarch *gdbarch, struct typ
 extern ULONGEST gdbarch_type_align (struct gdbarch *gdbarch, struct type *type);
 extern void set_gdbarch_type_align (struct gdbarch *gdbarch, gdbarch_type_align_ftype *type_align);
 
-/* Definition for an unknown syscall, used basically in error-cases.  */
-#define UNKNOWN_SYSCALL (-1)
-
 extern struct gdbarch_tdep *gdbarch_tdep (struct gdbarch *gdbarch);
 
 
diff --git a/gdb/gdbarch.sh b/gdb/gdbarch.sh
index bbfa8d2205..ff0e751f48 100755
--- a/gdb/gdbarch.sh
+++ b/gdb/gdbarch.sh
@@ -1393,9 +1393,6 @@ done
 # close it off
 cat <<EOF
 
-/* Definition for an unknown syscall, used basically in error-cases.  */
-#define UNKNOWN_SYSCALL (-1)
-
 extern struct gdbarch_tdep *gdbarch_tdep (struct gdbarch *gdbarch);
 
 
diff --git a/gdb/syscalls/gdb-syscalls.dtd b/gdb/syscalls/gdb-syscalls.dtd
index c2aa478aa4..6aa73f288a 100644
--- a/gdb/syscalls/gdb-syscalls.dtd
+++ b/gdb/syscalls/gdb-syscalls.dtd
@@ -12,4 +12,5 @@
 <!ATTLIST syscall
 	name			CDATA	#REQUIRED
 	number			CDATA	#REQUIRED
+	alias			CDATA	#IMPLIED
 	groups			CDATA	#IMPLIED>
diff --git a/gdb/xml-syscall.c b/gdb/xml-syscall.c
index c3cd425186..ba9df0475b 100644
--- a/gdb/xml-syscall.c
+++ b/gdb/xml-syscall.c
@@ -61,13 +61,11 @@ get_syscall_by_number (struct gdbarch *gdbarch,
   s->name = NULL;
 }
 
-void
-get_syscall_by_name (struct gdbarch *gdbarch, const char *syscall_name,
-		     struct syscall *s)
+std::vector<int>
+get_syscalls_by_name (struct gdbarch *gdbarch, const char *syscall_name)
 {
   syscall_warn_user ();
-  s->number = UNKNOWN_SYSCALL;
-  s->name = syscall_name;
+  return std::vector<int> ();
 }
 
 const char **
@@ -96,8 +94,8 @@ get_syscall_group_names (struct gdbarch *gdbarch)
 /* Structure which describes a syscall.  */
 struct syscall_desc
 {
-  syscall_desc (int number_, std::string name_)
-  : number (number_), name (name_)
+  syscall_desc (int number_, std::string name_, std::string alias_)
+  : number (number_), name (name_), alias (alias_)
   {}
 
   /* The syscall number.  */
@@ -107,6 +105,10 @@ struct syscall_desc
   /* The syscall name.  */
 
   std::string name;
+
+  /* An optional alias.  */
+
+  std::string alias;
 };
 
 typedef std::unique_ptr<syscall_desc> syscall_desc_up;
@@ -206,10 +208,11 @@ syscall_group_add_syscall (struct syscalls_info *syscalls_info,
 
 static void
 syscall_create_syscall_desc (struct syscalls_info *syscalls_info,
-			     const char *name, int number,
+			     const char *name, int number, const char *alias,
 			     char *groups)
 {
-  syscall_desc *sysdesc = new syscall_desc (number, name);
+  syscall_desc *sysdesc = new syscall_desc (number, name,
+					    alias != NULL ? alias : "");
 
   syscalls_info->syscalls.emplace_back (sysdesc);
 
@@ -234,6 +237,7 @@ syscall_start_syscall (struct gdb_xml_parser *parser,
   /* syscall info.  */
   char *name = NULL;
   int number = 0;
+  char *alias = NULL;
   char *groups = NULL;
 
   for (const gdb_xml_value &attr : attributes)
@@ -242,6 +246,8 @@ syscall_start_syscall (struct gdb_xml_parser *parser,
         name = (char *) attr.value.get ();
       else if (strcmp (attr.name, "number") == 0)
         number = * (ULONGEST *) attr.value.get ();
+      else if (strcmp (attr.name, "alias") == 0)
+        alias = (char *) attr.value.get ();
       else if (strcmp (attr.name, "groups") == 0)
         groups = (char *) attr.value.get ();
       else
@@ -250,7 +256,8 @@ syscall_start_syscall (struct gdb_xml_parser *parser,
     }
 
   gdb_assert (name);
-  syscall_create_syscall_desc (data->syscalls_info, name, number, groups);
+  syscall_create_syscall_desc (data->syscalls_info, name, number, alias,
+			       groups);
 }
 
 
@@ -258,6 +265,7 @@ syscall_start_syscall (struct gdb_xml_parser *parser,
 static const struct gdb_xml_attribute syscall_attr[] = {
   { "number", GDB_XML_AF_NONE, gdb_xml_parse_attr_ulongest, NULL },
   { "name", GDB_XML_AF_NONE, NULL, NULL },
+  { "alias", GDB_XML_AF_OPTIONAL, NULL, NULL },
   { "groups", GDB_XML_AF_OPTIONAL, NULL, NULL },
   { NULL, GDB_XML_AF_NONE, NULL, NULL }
 };
@@ -389,21 +397,18 @@ syscall_group_get_group_by_name (const struct syscalls_info *syscalls_info,
   return NULL;
 }
 
-static int
-xml_get_syscall_number (struct gdbarch *gdbarch,
-                        const char *syscall_name)
+static std::vector<int>
+xml_get_syscalls_by_name (struct gdbarch *gdbarch, const char *syscall_name)
 {
   struct syscalls_info *syscalls_info = gdbarch_syscalls_info (gdbarch);
+  std::vector<int> syscalls;
 
-  if (syscalls_info == NULL
-      || syscall_name == NULL)
-    return UNKNOWN_SYSCALL;
+  if (syscalls_info != NULL && syscall_name != NULL)
+    for (const syscall_desc_up &sysdesc : syscalls_info->syscalls)
+      if (sysdesc->name == syscall_name || sysdesc->alias == syscall_name)
+	syscalls.push_back (sysdesc->number);
 
-  for (const syscall_desc_up &sysdesc : syscalls_info->syscalls)
-    if (sysdesc->name == syscall_name)
-      return sysdesc->number;
-
-  return UNKNOWN_SYSCALL;
+  return syscalls;
 }
 
 static const char *
@@ -506,14 +511,12 @@ get_syscall_by_number (struct gdbarch *gdbarch,
   s->name = xml_get_syscall_name (gdbarch, syscall_number);
 }
 
-void
-get_syscall_by_name (struct gdbarch *gdbarch,
-		     const char *syscall_name, struct syscall *s)
+std::vector<int>
+get_syscalls_by_name (struct gdbarch *gdbarch, const char *syscall_name)
 {
   init_syscalls_info (gdbarch);
 
-  s->number = xml_get_syscall_number (gdbarch, syscall_name);
-  s->name = syscall_name;
+  return xml_get_syscalls_by_name (gdbarch, syscall_name);
 }
 
 const char **
diff --git a/gdb/xml-syscall.h b/gdb/xml-syscall.h
index 95c968c9c7..9bb97d0922 100644
--- a/gdb/xml-syscall.h
+++ b/gdb/xml-syscall.h
@@ -38,11 +38,12 @@ void set_xml_syscall_file_name (struct gdbarch *gdbarch,
 void get_syscall_by_number (struct gdbarch *gdbarch,
 			    int syscall_number, struct syscall *s);
 
-/* Function that retrieves the syscall number corresponding to the given
-   name.  It puts the requested information inside 'struct syscall'.  */
+/* Function that retrieves the syscall numbers corresponding to the
+   given name.  The numbers of all syscalls with either a name or
+   alias equal to SYSCALL_NAME are returned in a vector.  */
 
-void get_syscall_by_name (struct gdbarch *gdbarch,
-			  const char *syscall_name, struct syscall *s);
+std::vector<int> get_syscalls_by_name (struct gdbarch *gdbarch,
+				       const char *syscall_name);
 
 /* Function used to retrieve the list of syscalls in the system.  This list
    is returned as an array of strings.  Returns the list of syscalls in the
-- 
2.18.0

^ permalink raw reply	[flat|nested] 15+ messages in thread

* [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group.
  2018-11-06 17:56 [PATCH v2 0/3] Update FreeBSD's syscall table John Baldwin
@ 2018-11-06 17:56 ` John Baldwin
  2018-11-09  4:27   ` Kevin Buettner
  2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
                   ` (2 subsequent siblings)
  3 siblings, 1 reply; 15+ messages in thread
From: John Baldwin @ 2018-11-06 17:56 UTC (permalink / raw)
  To: gdb-patches

This removes the need for the caller to explicitly manage the memory
for the returned system call list.  This change only returns the
numbers rather than a vector of syscall structures since the caller
only needs the numbers.

gdb/ChangeLog:

	* break-catch-syscall.c (catch_syscall_split_args): Update for
	get_syscalls_by_group returning a vector.
	* xml-syscall.c [!HAVE_LIBEXPATH] (get_syscalls_by_group): Return
	empty vector.
	[HAVE_LIBEXPAT] (xml_list_syscalls_by_group)
	(get_syscalls_by_group): Return a vector of integers.
	* xml-syscall.h (get_syscalls_by_group): Change return type to a
	vector of integers.
---
 gdb/ChangeLog             | 11 +++++++++++
 gdb/break-catch-syscall.c | 16 +++++-----------
 gdb/xml-syscall.c         | 36 ++++++++++--------------------------
 gdb/xml-syscall.h         |  8 +++-----
 4 files changed, 29 insertions(+), 42 deletions(-)

diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 68ecef7728..9f4c450e4e 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,14 @@
+2018-11-06  John Baldwin  <jhb@FreeBSD.org>
+
+	* break-catch-syscall.c (catch_syscall_split_args): Update for
+	get_syscalls_by_group returning a vector.
+	* xml-syscall.c [!HAVE_LIBEXPATH] (get_syscalls_by_group): Return
+	empty vector.
+	[HAVE_LIBEXPAT] (xml_list_syscalls_by_group)
+	(get_syscalls_by_group): Return a vector of integers.
+	* xml-syscall.h (get_syscalls_by_group): Change return type to a
+	vector of integers.
+
 2018-11-06  John Baldwin  <jhb@FreeBSD.org>
 
 	* riscv-fbsd-nat.c (getregs_supplies): Return true for
diff --git a/gdb/break-catch-syscall.c b/gdb/break-catch-syscall.c
index 93ef74c249..8e1de10fa7 100644
--- a/gdb/break-catch-syscall.c
+++ b/gdb/break-catch-syscall.c
@@ -409,25 +409,19 @@ catch_syscall_split_args (const char *arg)
 	{
 	  /* We have a syscall group.  Let's expand it into a syscall
 	     list before inserting.  */
-	  struct syscall *syscall_list;
 	  const char *group_name;
 
 	  /* Skip over "g:" and "group:" prefix strings.  */
 	  group_name = strchr (cur_name, ':') + 1;
 
-	  syscall_list = get_syscalls_by_group (gdbarch, group_name);
+	  std::vector<int> numbers = get_syscalls_by_group (gdbarch,
+							    group_name);
 
-	  if (syscall_list == NULL)
+	  if (numbers.empty ())
 	    error (_("Unknown syscall group '%s'."), group_name);
 
-	  for (i = 0; syscall_list[i].name != NULL; i++)
-	    {
-	      /* Insert each syscall that are part of the group.  No
-		 need to check if it is valid.  */
-	      result.push_back (syscall_list[i].number);
-	    }
-
-	  xfree (syscall_list);
+	  for (int number : numbers)
+	    result.push_back (number);
 	}
       else
 	{
diff --git a/gdb/xml-syscall.c b/gdb/xml-syscall.c
index bf17642911..c3cd425186 100644
--- a/gdb/xml-syscall.c
+++ b/gdb/xml-syscall.c
@@ -77,11 +77,11 @@ get_syscall_names (struct gdbarch *gdbarch)
   return NULL;
 }
 
-struct syscall *
+std::vector<int>
 get_syscalls_by_group (struct gdbarch *gdbarch, const char *group)
 {
   syscall_warn_user ();
-  return NULL;
+  return std::vector<int> ();
 }
 
 const char **
@@ -444,38 +444,22 @@ xml_list_of_syscalls (struct gdbarch *gdbarch)
 }
 
 /* Iterate over the syscall_group_desc element to return a list of
-   syscalls that are part of the given group, terminated by an empty
-   element.  If the syscall group doesn't exist, return NULL.  */
+   syscalls that are part of the given group.  */
 
-static struct syscall *
+static std::vector<int>
 xml_list_syscalls_by_group (struct gdbarch *gdbarch, const char *group)
 {
   struct syscalls_info *syscalls_info = gdbarch_syscalls_info (gdbarch);
   struct syscall_group_desc *groupdesc;
-  struct syscall *syscalls = NULL;
-  int nsyscalls;
-  int i;
+  std::vector<int> syscalls;
 
   if (syscalls_info == NULL)
-    return NULL;
+    return syscalls;
 
   groupdesc = syscall_group_get_group_by_name (syscalls_info, group);
-  if (groupdesc == NULL)
-    return NULL;
-
-  nsyscalls = groupdesc->syscalls.size ();
-  syscalls = (struct syscall*) xmalloc ((nsyscalls + 1)
-					* sizeof (struct syscall));
-
-  for (i = 0; i < groupdesc->syscalls.size (); i++)
-    {
-      syscalls[i].name = groupdesc->syscalls[i]->name.c_str ();
-      syscalls[i].number = groupdesc->syscalls[i]->number;
-    }
-
-  /* Add final element marker.  */
-  syscalls[i].name = NULL;
-  syscalls[i].number = 0;
+  if (groupdesc != NULL)
+    for (const struct syscall_desc *sysdesc : groupdesc->syscalls)
+      syscalls.push_back (sysdesc->number);
 
   return syscalls;
 }
@@ -542,7 +526,7 @@ get_syscall_names (struct gdbarch *gdbarch)
 
 /* See comment in xml-syscall.h.  */
 
-struct syscall *
+std::vector<int>
 get_syscalls_by_group (struct gdbarch *gdbarch, const char *group)
 {
   init_syscalls_info (gdbarch);
diff --git a/gdb/xml-syscall.h b/gdb/xml-syscall.h
index 4429d66400..95c968c9c7 100644
--- a/gdb/xml-syscall.h
+++ b/gdb/xml-syscall.h
@@ -51,12 +51,10 @@ void get_syscall_by_name (struct gdbarch *gdbarch,
 const char **get_syscall_names (struct gdbarch *gdbarch);
 
 /* Function used to retrieve the list of syscalls of a given group in
-   the system.  Return a list of syscalls that are element of the
-   group, terminated by an empty element. The list is malloc'ed
-   and must be freed by the caller.  If group doesn't exist, return
-   NULL.  */
+   the system.  Return a vector of syscall numbers that are elements
+   of the group.  */
 
-struct syscall *get_syscalls_by_group (struct gdbarch *gdbarch,
+std::vector<int> get_syscalls_by_group (struct gdbarch *gdbarch,
 				       const char *group);
 
 /* Function used to retrieve the list of syscall groups in the system.
-- 
2.18.0

^ permalink raw reply	[flat|nested] 15+ messages in thread

* [PATCH v2 0/3] Update FreeBSD's syscall table
@ 2018-11-06 17:56 John Baldwin
  2018-11-06 17:56 ` [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group John Baldwin
                   ` (3 more replies)
  0 siblings, 4 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-06 17:56 UTC (permalink / raw)
  To: gdb-patches

Relative to the first version of this patch series, I've fixed some
nits noted by reviewers.  One thing I have not changed is I chose to
keep the changed API of returning a vector of integers from
get_syscalls_by_name().  I have expanded the comment in xml-syscall.h
a bit to be more clear on why it returns a vector of integers.

I also added a new patch (patch 1) to change the similar
get_syscalls_by_group() to return a vector of integers instead of an
allocated array of structures.  This results in more symmetry in the
final code in break-catch-syscall.c.  There wasn't a very clean way to
share the bits of duplicated code however.

John Baldwin (3):
  Return a vector of integers from get_syscalls_by_group.
  Add an optional "alias" attribute to syscall entries.
  Update the FreeBSD system call table to match FreeBSD 12.0.

 gdb/ChangeLog                  |  37 ++++++++++++
 gdb/break-catch-syscall.c      |  27 ++++-----
 gdb/gdbarch.h                  |   3 -
 gdb/gdbarch.sh                 |   3 -
 gdb/syscalls/freebsd.xml       | 107 ++++++++++++++++++++++++++-------
 gdb/syscalls/gdb-syscalls.dtd  |   1 +
 gdb/syscalls/update-freebsd.sh |  77 ++++++++++++++++++++++++
 gdb/xml-syscall.c              |  91 ++++++++++++----------------
 gdb/xml-syscall.h              |  17 +++---
 9 files changed, 258 insertions(+), 105 deletions(-)
 create mode 100755 gdb/syscalls/update-freebsd.sh

-- 
2.18.0

^ permalink raw reply	[flat|nested] 15+ messages in thread

* [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0.
  2018-11-06 17:56 [PATCH v2 0/3] Update FreeBSD's syscall table John Baldwin
  2018-11-06 17:56 ` [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group John Baldwin
  2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
@ 2018-11-06 17:56 ` John Baldwin
  2018-11-09  4:38   ` Kevin Buettner
  2018-11-09 16:34   ` Pedro Alves
  2018-11-06 18:49 ` [PATCH v2 0/3] Update FreeBSD's syscall table Sergio Durigan Junior
  3 siblings, 2 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-06 17:56 UTC (permalink / raw)
  To: gdb-patches

Add a script to generate the FreeBSD XML system call table from the
sys/sys/syscall.h file in the kernel source tree.  For ABI
compatiblity system calls used by older binaries (such as
freebsd11_kevent()), the original system call name is used as an
alias.

Run this script against the current syscall.h file in FreeBSD's head
branch which is expected to be the file used in 12.0 (head is
currently in code freeze as part of the 12.0 release process).

gdb/ChangeLog:

	* syscalls/update-freebsd.sh: New file.
	* syscalls/freebsd.xml: Regenerate.
---
 gdb/ChangeLog                  |   5 ++
 gdb/syscalls/freebsd.xml       | 107 ++++++++++++++++++++++++++-------
 gdb/syscalls/update-freebsd.sh |  77 ++++++++++++++++++++++++
 3 files changed, 167 insertions(+), 22 deletions(-)
 create mode 100755 gdb/syscalls/update-freebsd.sh

diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 487c97a957..e47c4994fc 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,8 @@
+2018-11-06  John Baldwin  <jhb@FreeBSD.org>
+
+	* syscalls/update-freebsd.sh: New file.
+	* syscalls/freebsd.xml: Regenerate.
+
 2018-11-06  John Baldwin  <jhb@FreeBSD.org>
 
 	* break-catch-syscall.c (catch_syscall_split_args): Update for
diff --git a/gdb/syscalls/freebsd.xml b/gdb/syscalls/freebsd.xml
index 810258a850..773e0be5f8 100644
--- a/gdb/syscalls/freebsd.xml
+++ b/gdb/syscalls/freebsd.xml
@@ -24,12 +24,14 @@
   <syscall name="wait4" number="7"/>
   <syscall name="link" number="9"/>
   <syscall name="unlink" number="10"/>
+  <syscall name="execv" number="11"/>
   <syscall name="chdir" number="12"/>
   <syscall name="fchdir" number="13"/>
-  <syscall name="mknod" number="14"/>
+  <syscall name="freebsd11_mknod" number="14" alias="mknod"/>
   <syscall name="chmod" number="15"/>
   <syscall name="chown" number="16"/>
   <syscall name="break" number="17"/>
+  <syscall name="freebsd4_getfsstat" number="18" alias="getfsstat"/>
   <syscall name="getpid" number="20"/>
   <syscall name="mount" number="21"/>
   <syscall name="unmount" number="22"/>
@@ -50,7 +52,7 @@
   <syscall name="kill" number="37"/>
   <syscall name="getppid" number="39"/>
   <syscall name="dup" number="41"/>
-  <syscall name="pipe" number="42"/>
+  <syscall name="freebsd10_pipe" number="42" alias="pipe"/>
   <syscall name="getegid" number="43"/>
   <syscall name="profil" number="44"/>
   <syscall name="ktrace" number="45"/>
@@ -69,12 +71,16 @@
   <syscall name="chroot" number="61"/>
   <syscall name="msync" number="65"/>
   <syscall name="vfork" number="66"/>
+  <syscall name="vread" number="67"/>
+  <syscall name="vwrite" number="68"/>
   <syscall name="sbrk" number="69"/>
   <syscall name="sstk" number="70"/>
-  <syscall name="vadvise" number="72"/>
+  <syscall name="freebsd11_vadvise" number="72" alias="vadvise"/>
   <syscall name="munmap" number="73"/>
   <syscall name="mprotect" number="74"/>
   <syscall name="madvise" number="75"/>
+  <syscall name="vhangup" number="76"/>
+  <syscall name="vlimit" number="77"/>
   <syscall name="mincore" number="78"/>
   <syscall name="getgroups" number="79"/>
   <syscall name="setgroups" number="80"/>
@@ -95,6 +101,8 @@
   <syscall name="bind" number="104"/>
   <syscall name="setsockopt" number="105"/>
   <syscall name="listen" number="106"/>
+  <syscall name="vtimes" number="107"/>
+  <syscall name="vtrace" number="115"/>
   <syscall name="gettimeofday" number="116"/>
   <syscall name="getrusage" number="117"/>
   <syscall name="getsockopt" number="118"/>
@@ -119,27 +127,42 @@
   <syscall name="quotactl" number="148"/>
   <syscall name="nlm_syscall" number="154"/>
   <syscall name="nfssvc" number="155"/>
+  <syscall name="freebsd4_statfs" number="157" alias="statfs"/>
+  <syscall name="freebsd4_fstatfs" number="158" alias="fstatfs"/>
   <syscall name="lgetfh" number="160"/>
   <syscall name="getfh" number="161"/>
+  <syscall name="freebsd4_getdomainname" number="162" alias="getdomainname"/>
+  <syscall name="freebsd4_setdomainname" number="163" alias="setdomainname"/>
+  <syscall name="freebsd4_uname" number="164" alias="uname"/>
   <syscall name="sysarch" number="165"/>
   <syscall name="rtprio" number="166"/>
   <syscall name="semsys" number="169"/>
   <syscall name="msgsys" number="170"/>
   <syscall name="shmsys" number="171"/>
+  <syscall name="freebsd6_pread" number="173" alias="pread"/>
+  <syscall name="freebsd6_pwrite" number="174" alias="pwrite"/>
   <syscall name="setfib" number="175"/>
   <syscall name="ntp_adjtime" number="176"/>
   <syscall name="setgid" number="181"/>
   <syscall name="setegid" number="182"/>
   <syscall name="seteuid" number="183"/>
-  <syscall name="stat" number="188"/>
-  <syscall name="fstat" number="189"/>
-  <syscall name="lstat" number="190"/>
+  <syscall name="lfs_bmapv" number="184"/>
+  <syscall name="lfs_markv" number="185"/>
+  <syscall name="lfs_segclean" number="186"/>
+  <syscall name="lfs_segwait" number="187"/>
+  <syscall name="freebsd11_stat" number="188" alias="stat"/>
+  <syscall name="freebsd11_fstat" number="189" alias="fstat"/>
+  <syscall name="freebsd11_lstat" number="190" alias="lstat"/>
   <syscall name="pathconf" number="191"/>
   <syscall name="fpathconf" number="192"/>
   <syscall name="getrlimit" number="194"/>
   <syscall name="setrlimit" number="195"/>
-  <syscall name="getdirentries" number="196"/>
+  <syscall name="freebsd11_getdirentries" number="196" alias="getdirentries"/>
+  <syscall name="freebsd6_mmap" number="197" alias="mmap"/>
   <syscall name="__syscall" number="198"/>
+  <syscall name="freebsd6_lseek" number="199" alias="lseek"/>
+  <syscall name="freebsd6_truncate" number="200" alias="truncate"/>
+  <syscall name="freebsd6_ftruncate" number="201" alias="ftruncate"/>
   <syscall name="__sysctl" number="202"/>
   <syscall name="mlock" number="203"/>
   <syscall name="munlock" number="204"/>
@@ -147,15 +170,16 @@
   <syscall name="futimes" number="206"/>
   <syscall name="getpgid" number="207"/>
   <syscall name="poll" number="209"/>
-  <syscall name="freebsd7___semctl" number="220"/>
+  <syscall name="freebsd7___semctl" number="220" alias="__semctl"/>
   <syscall name="semget" number="221"/>
   <syscall name="semop" number="222"/>
-  <syscall name="freebsd7_msgctl" number="224"/>
+  <syscall name="semconfig" number="223"/>
+  <syscall name="freebsd7_msgctl" number="224" alias="msgctl"/>
   <syscall name="msgget" number="225"/>
   <syscall name="msgsnd" number="226"/>
   <syscall name="msgrcv" number="227"/>
   <syscall name="shmat" number="228"/>
-  <syscall name="freebsd7_shmctl" number="229"/>
+  <syscall name="freebsd7_shmctl" number="229" alias="shmctl"/>
   <syscall name="shmdt" number="230"/>
   <syscall name="shmget" number="231"/>
   <syscall name="clock_gettime" number="232"/>
@@ -170,6 +194,7 @@
   <syscall name="ffclock_getcounter" number="241"/>
   <syscall name="ffclock_setestimate" number="242"/>
   <syscall name="ffclock_getestimate" number="243"/>
+  <syscall name="clock_nanosleep" number="244"/>
   <syscall name="clock_getcpuclockid2" number="247"/>
   <syscall name="ntp_gettime" number="248"/>
   <syscall name="minherit" number="250"/>
@@ -180,18 +205,19 @@
   <syscall name="aio_read" number="255"/>
   <syscall name="aio_write" number="256"/>
   <syscall name="lio_listio" number="257"/>
-  <syscall name="getdents" number="272"/>
+  <syscall name="freebsd11_getdents" number="272" alias="getdents"/>
   <syscall name="lchmod" number="274"/>
   <syscall name="netbsd_lchown" number="275"/>
   <syscall name="lutimes" number="276"/>
   <syscall name="netbsd_msync" number="277"/>
-  <syscall name="nstat" number="278"/>
-  <syscall name="nfstat" number="279"/>
-  <syscall name="nlstat" number="280"/>
+  <syscall name="freebsd11_nstat" number="278" alias="nstat"/>
+  <syscall name="freebsd11_nfstat" number="279" alias="nfstat"/>
+  <syscall name="freebsd11_nlstat" number="280" alias="nlstat"/>
   <syscall name="preadv" number="289"/>
   <syscall name="pwritev" number="290"/>
+  <syscall name="freebsd4_fhstatfs" number="297" alias="fhstatfs"/>
   <syscall name="fhopen" number="298"/>
-  <syscall name="fhstat" number="299"/>
+  <syscall name="freebsd11_fhstat" number="299" alias="fhstat"/>
   <syscall name="modnext" number="300"/>
   <syscall name="modstat" number="301"/>
   <syscall name="modfnext" number="302"/>
@@ -205,11 +231,17 @@
   <syscall name="getsid" number="310"/>
   <syscall name="setresuid" number="311"/>
   <syscall name="setresgid" number="312"/>
+  <syscall name="signanosleep" number="313"/>
   <syscall name="aio_return" number="314"/>
   <syscall name="aio_suspend" number="315"/>
   <syscall name="aio_cancel" number="316"/>
   <syscall name="aio_error" number="317"/>
+  <syscall name="freebsd6_aio_read" number="318" alias="aio_read"/>
+  <syscall name="freebsd6_aio_write" number="319" alias="aio_write"/>
+  <syscall name="freebsd6_lio_listio" number="320" alias="lio_listio"/>
   <syscall name="yield" number="321"/>
+  <syscall name="thr_sleep" number="322"/>
+  <syscall name="thr_wakeup" number="323"/>
   <syscall name="mlockall" number="324"/>
   <syscall name="munlockall" number="325"/>
   <syscall name="__getcwd" number="326"/>
@@ -222,12 +254,15 @@
   <syscall name="sched_get_priority_min" number="333"/>
   <syscall name="sched_rr_get_interval" number="334"/>
   <syscall name="utrace" number="335"/>
+  <syscall name="freebsd4_sendfile" number="336" alias="sendfile"/>
   <syscall name="kldsym" number="337"/>
   <syscall name="jail" number="338"/>
   <syscall name="nnpfs_syscall" number="339"/>
   <syscall name="sigprocmask" number="340"/>
   <syscall name="sigsuspend" number="341"/>
+  <syscall name="freebsd4_sigaction" number="342" alias="sigaction"/>
   <syscall name="sigpending" number="343"/>
+  <syscall name="freebsd4_sigreturn" number="344" alias="sigreturn"/>
   <syscall name="sigtimedwait" number="345"/>
   <syscall name="sigwaitinfo" number="346"/>
   <syscall name="__acl_get_file" number="347"/>
@@ -246,14 +281,26 @@
   <syscall name="getresuid" number="360"/>
   <syscall name="getresgid" number="361"/>
   <syscall name="kqueue" number="362"/>
-  <syscall name="kevent" number="363"/>
+  <syscall name="freebsd11_kevent" number="363" alias="kevent"/>
+  <syscall name="__cap_get_proc" number="364"/>
+  <syscall name="__cap_set_proc" number="365"/>
+  <syscall name="__cap_get_fd" number="366"/>
+  <syscall name="__cap_get_file" number="367"/>
+  <syscall name="__cap_set_fd" number="368"/>
+  <syscall name="__cap_set_file" number="369"/>
   <syscall name="extattr_set_fd" number="371"/>
   <syscall name="extattr_get_fd" number="372"/>
   <syscall name="extattr_delete_fd" number="373"/>
   <syscall name="__setugid" number="374"/>
+  <syscall name="nfsclnt" number="375"/>
   <syscall name="eaccess" number="376"/>
   <syscall name="afs3_syscall" number="377"/>
   <syscall name="nmount" number="378"/>
+  <syscall name="kse_exit" number="379"/>
+  <syscall name="kse_wakeup" number="380"/>
+  <syscall name="kse_create" number="381"/>
+  <syscall name="kse_thr_interrupt" number="382"/>
+  <syscall name="kse_release" number="383"/>
   <syscall name="__mac_get_proc" number="384"/>
   <syscall name="__mac_set_proc" number="385"/>
   <syscall name="__mac_get_fd" number="386"/>
@@ -265,10 +312,10 @@
   <syscall name="uuidgen" number="392"/>
   <syscall name="sendfile" number="393"/>
   <syscall name="mac_syscall" number="394"/>
-  <syscall name="getfsstat" number="395"/>
-  <syscall name="statfs" number="396"/>
-  <syscall name="fstatfs" number="397"/>
-  <syscall name="fhstatfs" number="398"/>
+  <syscall name="freebsd11_getfsstat" number="395" alias="getfsstat"/>
+  <syscall name="freebsd11_statfs" number="396" alias="statfs"/>
+  <syscall name="freebsd11_fstatfs" number="397" alias="fstatfs"/>
+  <syscall name="freebsd11_fhstatfs" number="398" alias="fhstatfs"/>
   <syscall name="ksem_close" number="400"/>
   <syscall name="ksem_post" number="401"/>
   <syscall name="ksem_wait" number="402"/>
@@ -304,6 +351,7 @@
   <syscall name="extattr_list_fd" number="437"/>
   <syscall name="extattr_list_file" number="438"/>
   <syscall name="extattr_list_link" number="439"/>
+  <syscall name="kse_switchin" number="440"/>
   <syscall name="ksem_timedwait" number="441"/>
   <syscall name="thr_suspend" number="442"/>
   <syscall name="thr_wake" number="443"/>
@@ -352,12 +400,12 @@
   <syscall name="fchmodat" number="490"/>
   <syscall name="fchownat" number="491"/>
   <syscall name="fexecve" number="492"/>
-  <syscall name="fstatat" number="493"/>
+  <syscall name="freebsd11_fstatat" number="493" alias="fstatat"/>
   <syscall name="futimesat" number="494"/>
   <syscall name="linkat" number="495"/>
   <syscall name="mkdirat" number="496"/>
   <syscall name="mkfifoat" number="497"/>
-  <syscall name="mknodat" number="498"/>
+  <syscall name="freebsd11_mknodat" number="498" alias="mknodat"/>
   <syscall name="openat" number="499"/>
   <syscall name="readlinkat" number="500"/>
   <syscall name="renameat" number="501"/>
@@ -373,6 +421,7 @@
   <syscall name="msgctl" number="511"/>
   <syscall name="shmctl" number="512"/>
   <syscall name="lpathconf" number="513"/>
+  <syscall name="cap_new" number="514"/>
   <syscall name="__cap_rights_get" number="515"/>
   <syscall name="cap_enter" number="516"/>
   <syscall name="cap_getmode" number="517"/>
@@ -407,4 +456,18 @@
   <syscall name="utimensat" number="547"/>
   <syscall name="numa_getaffinity" number="548"/>
   <syscall name="numa_setaffinity" number="549"/>
+  <syscall name="fdatasync" number="550"/>
+  <syscall name="fstat" number="551"/>
+  <syscall name="fstatat" number="552"/>
+  <syscall name="fhstat" number="553"/>
+  <syscall name="getdirentries" number="554"/>
+  <syscall name="statfs" number="555"/>
+  <syscall name="fstatfs" number="556"/>
+  <syscall name="getfsstat" number="557"/>
+  <syscall name="fhstatfs" number="558"/>
+  <syscall name="mknodat" number="559"/>
+  <syscall name="kevent" number="560"/>
+  <syscall name="cpuset_getdomain" number="561"/>
+  <syscall name="cpuset_setdomain" number="562"/>
+  <syscall name="getrandom" number="563"/>
 </syscalls_info>
diff --git a/gdb/syscalls/update-freebsd.sh b/gdb/syscalls/update-freebsd.sh
new file mode 100755
index 0000000000..8699faa873
--- /dev/null
+++ b/gdb/syscalls/update-freebsd.sh
@@ -0,0 +1,77 @@
+#! /bin/sh
+
+# Copyright (C) 2011-2018 Free Software Foundation, Inc.
+#
+# This file is part of GDB.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Usage: update-freebsd.sh <path-to-syscall.h>
+# Update the freebsd.xml file.
+#
+# FreeBSD uses the same list of system calls on all architectures.
+# The list is defined in the sys/kern/syscalls.master file in the
+# FreeBSD source tree.  This file is used as an input to generate
+# several files that are also stored in FreeBSD's source tree.  This
+# script parses one of those generated files (sys/sys/syscall.h)
+# rather than syscalls.master as syscall.h is easier to parse.
+
+if [ $# -ne 1 ]; then
+   echo "Error: Path to syscall.h missing. Aborting."
+   echo "Usage: update-gnulib.sh <path-to-syscall.h>"
+   exit 1
+fi
+
+cat > freebsd.xml.tmp <<EOF
+<?xml version="1.0"?>
+<!-- Copyright (C) 2009-2018 Free Software Foundation, Inc.
+
+     Copying and distribution of this file, with or without modification,
+     are permitted in any medium without royalty provided the copyright
+     notice and this notice are preserved.  -->
+
+<!DOCTYPE feature SYSTEM "gdb-syscalls.dtd">
+
+<!-- This file was generated using the following file:
+
+     /usr/src/sys/sys/syscall.h
+
+     The file mentioned above belongs to the FreeBSD Kernel.  -->
+
+<syscalls_info>
+EOF
+
+awk '
+/MAXSYSCALL/ {
+    next
+}
+/^#define/ {
+    sub(/^SYS_/,"",$2);
+    printf "  <syscall name=\"%s\" number=\"%s\"", $2, $3
+    if (sub(/^freebsd[0-9]*_/,"",$2) != 0)
+        printf " alias=\"%s\"", $2
+    printf "/>\n"
+}
+/\/\* [0-9]* is obsolete [a-z_]* \*\// {
+    printf "  <syscall name=\"%s\" number=\"%s\"/>\n", $5, $2
+}
+/\/\* [0-9]* is freebsd[0-9]* [a-z_]* \*\// {
+    printf "  <syscall name=\"%s_%s\" number=\"%s\" alias=\"%s\"/>\n", $4, $5, $2, $5
+}' $1 >> freebsd.xml.tmp
+
+cat >> freebsd.xml.tmp <<EOF
+</syscalls_info>
+EOF
+
+../../move-if-change freebsd.xml.tmp freebsd.xml
-- 
2.18.0

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 0/3] Update FreeBSD's syscall table
  2018-11-06 17:56 [PATCH v2 0/3] Update FreeBSD's syscall table John Baldwin
                   ` (2 preceding siblings ...)
  2018-11-06 17:56 ` [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0 John Baldwin
@ 2018-11-06 18:49 ` Sergio Durigan Junior
  3 siblings, 0 replies; 15+ messages in thread
From: Sergio Durigan Junior @ 2018-11-06 18:49 UTC (permalink / raw)
  To: John Baldwin; +Cc: gdb-patches

On Tuesday, November 06 2018, John Baldwin wrote:

> Relative to the first version of this patch series, I've fixed some
> nits noted by reviewers.  One thing I have not changed is I chose to
> keep the changed API of returning a vector of integers from
> get_syscalls_by_name().  I have expanded the comment in xml-syscall.h
> a bit to be more clear on why it returns a vector of integers.
>
> I also added a new patch (patch 1) to change the similar
> get_syscalls_by_group() to return a vector of integers instead of an
> allocated array of structures.  This results in more symmetry in the
> final code in break-catch-syscall.c.  There wasn't a very clean way to
> share the bits of duplicated code however.

I've read the patch series again, and it looks fine to me.  I'm still
not 100% happy with get_syscalls_by_name returning a vector, but this is
a minor thing (and a personal preference) and shouldn't block the patch.
Thanks for addressing the comments I've made, and sorry for not replying
to you e-mail (for some reason, I didn't get it in my INBOX).

I am not a global maintainer, BTW.

> John Baldwin (3):
>   Return a vector of integers from get_syscalls_by_group.
>   Add an optional "alias" attribute to syscall entries.
>   Update the FreeBSD system call table to match FreeBSD 12.0.
>
>  gdb/ChangeLog                  |  37 ++++++++++++
>  gdb/break-catch-syscall.c      |  27 ++++-----
>  gdb/gdbarch.h                  |   3 -
>  gdb/gdbarch.sh                 |   3 -
>  gdb/syscalls/freebsd.xml       | 107 ++++++++++++++++++++++++++-------
>  gdb/syscalls/gdb-syscalls.dtd  |   1 +
>  gdb/syscalls/update-freebsd.sh |  77 ++++++++++++++++++++++++
>  gdb/xml-syscall.c              |  91 ++++++++++++----------------
>  gdb/xml-syscall.h              |  17 +++---
>  9 files changed, 258 insertions(+), 105 deletions(-)
>  create mode 100755 gdb/syscalls/update-freebsd.sh
>
> -- 
> 2.18.0

-- 
Sergio
GPG key ID: 237A 54B1 0287 28BF 00EF  31F4 D0EB 7628 65FC 5E36
Please send encrypted e-mail if possible
http://sergiodj.net/

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group.
  2018-11-06 17:56 ` [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group John Baldwin
@ 2018-11-09  4:27   ` Kevin Buettner
  2018-11-09 17:55     ` John Baldwin
  0 siblings, 1 reply; 15+ messages in thread
From: Kevin Buettner @ 2018-11-09  4:27 UTC (permalink / raw)
  To: gdb-patches; +Cc: John Baldwin

On Tue,  6 Nov 2018 09:54:29 -0800
John Baldwin <jhb@FreeBSD.org> wrote:

> This removes the need for the caller to explicitly manage the memory
> for the returned system call list.  This change only returns the
> numbers rather than a vector of syscall structures since the caller
> only needs the numbers.
> 
> gdb/ChangeLog:
> 
> 	* break-catch-syscall.c (catch_syscall_split_args): Update for
> 	get_syscalls_by_group returning a vector.
> 	* xml-syscall.c [!HAVE_LIBEXPATH] (get_syscalls_by_group): Return

s/HAVE_LIBEXPATH/HAVE_LIBEXPAT/

> 	empty vector.
> 	[HAVE_LIBEXPAT] (xml_list_syscalls_by_group)
> 	(get_syscalls_by_group): Return a vector of integers.
> 	* xml-syscall.h (get_syscalls_by_group): Change return type to a
> 	vector of integers.

Otherwise, okay.

Kevin

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
@ 2018-11-09  4:34   ` Kevin Buettner
  2018-11-09 15:28   ` Simon Marchi
  2018-11-09 16:31   ` Pedro Alves
  2 siblings, 0 replies; 15+ messages in thread
From: Kevin Buettner @ 2018-11-09  4:34 UTC (permalink / raw)
  To: gdb-patches; +Cc: John Baldwin

On Tue,  6 Nov 2018 09:54:30 -0800
John Baldwin <jhb@FreeBSD.org> wrote:

> When setting a syscall catchpoint by name, catch syscalls whose name
> or alias matches the requested string.
> 
> When the ABI of a system call is changed in the FreeBSD kernel, this
> is implemented by leaving a compatibility system call using the old
> ABI at the existing "slot" and allocating a new system call for the
> version using the new ABI.  For example, new fields were added to the
> 'struct kevent' used by the kevent() system call in FreeBSD 12.  The
> previous kevent() system call in FreeBSD 12 kernels is now called
> freebsd11_kevent() and is still used by older binaries compiled
> against the older ABI.  The freebsd11_kevent() system call can be
> tagged with an "alias" attribute of "kevent" permitting 'catch syscall
> kevent' to catch both system calls and providing the expected user
> behavior for both old and new binaries.  It also provides the expected
> behavior if GDB is compiled on an older host (such as a FreeBSD 11
> host).
> 
> gdb/ChangeLog:
> 
> 	* break-catch-syscall.c (catch_syscall_split_args): Update for
> 	get_syscalls_by_name returning a vector.
> 	* gdbarch.sh (UNKNOWN_SYSCALL): Remove.
> 	* gdbarch.h: Regenerate.
> 	* syscalls/gdb-syscalls.dtd (syscall): Add alias attribute.
> 	* xml-syscall.c [!HAVE_LIBEXPAT] (get_syscalls_by_name): Rename
> 	from get_syscall_by_name.  Now returns a vector of integers.
> 	[HAVE_LIBEXPAT] (struct syscall_desc): Add alias member.
> 	(syscall_create_syscall_desc): Add alias parameter and pass it to
> 	syscall_desc constructor.
> 	(syscall_start_syscall): Handle alias attribute.
> 	(syscall_attr): Add alias attribute.
> 	(xml_get_syscalls_by_name): Rename from xml_get_syscall_number.
> 	Now returns a vector of integers.  Add syscalls whose alias or
> 	name matches the requested name.
> 	(get_syscalls_by_name): Rename from get_syscall_by_name.  Now
> 	returns a vector of integers.
> 	* xml-syscall.h (get_syscalls_by_name): Likewise.

Okay.

Kevin

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0.
  2018-11-06 17:56 ` [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0 John Baldwin
@ 2018-11-09  4:38   ` Kevin Buettner
  2018-11-09 16:34   ` Pedro Alves
  1 sibling, 0 replies; 15+ messages in thread
From: Kevin Buettner @ 2018-11-09  4:38 UTC (permalink / raw)
  To: gdb-patches; +Cc: John Baldwin

On Tue,  6 Nov 2018 09:54:31 -0800
John Baldwin <jhb@FreeBSD.org> wrote:

> Add a script to generate the FreeBSD XML system call table from the
> sys/sys/syscall.h file in the kernel source tree.  For ABI
> compatiblity system calls used by older binaries (such as
> freebsd11_kevent()), the original system call name is used as an
> alias.
> 
> Run this script against the current syscall.h file in FreeBSD's head
> branch which is expected to be the file used in 12.0 (head is
> currently in code freeze as part of the 12.0 release process).
> 
> gdb/ChangeLog:
> 
> 	* syscalls/update-freebsd.sh: New file.
> 	* syscalls/freebsd.xml: Regenerate.

LGTM.

Kevin

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
  2018-11-09  4:34   ` Kevin Buettner
@ 2018-11-09 15:28   ` Simon Marchi
  2018-11-09 15:36     ` Simon Marchi
  2018-11-09 16:31   ` Pedro Alves
  2 siblings, 1 reply; 15+ messages in thread
From: Simon Marchi @ 2018-11-09 15:28 UTC (permalink / raw)
  To: John Baldwin; +Cc: gdb-patches

On 2018-11-06 12:54, John Baldwin wrote:
> When setting a syscall catchpoint by name, catch syscalls whose name
> or alias matches the requested string.
> 
> When the ABI of a system call is changed in the FreeBSD kernel, this
> is implemented by leaving a compatibility system call using the old
> ABI at the existing "slot" and allocating a new system call for the
> version using the new ABI.  For example, new fields were added to the
> 'struct kevent' used by the kevent() system call in FreeBSD 12.  The
> previous kevent() system call in FreeBSD 12 kernels is now called
> freebsd11_kevent() and is still used by older binaries compiled
> against the older ABI.  The freebsd11_kevent() system call can be
> tagged with an "alias" attribute of "kevent" permitting 'catch syscall
> kevent' to catch both system calls and providing the expected user
> behavior for both old and new binaries.  It also provides the expected
> behavior if GDB is compiled on an older host (such as a FreeBSD 11
> host).

Will we ever need to provide more than one alias to a syscall?

Simon

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-09 15:28   ` Simon Marchi
@ 2018-11-09 15:36     ` Simon Marchi
  0 siblings, 0 replies; 15+ messages in thread
From: Simon Marchi @ 2018-11-09 15:36 UTC (permalink / raw)
  To: John Baldwin; +Cc: gdb-patches

On 2018-11-09 10:28, Simon Marchi wrote:
> On 2018-11-06 12:54, John Baldwin wrote:
>> When setting a syscall catchpoint by name, catch syscalls whose name
>> or alias matches the requested string.
>> 
>> When the ABI of a system call is changed in the FreeBSD kernel, this
>> is implemented by leaving a compatibility system call using the old
>> ABI at the existing "slot" and allocating a new system call for the
>> version using the new ABI.  For example, new fields were added to the
>> 'struct kevent' used by the kevent() system call in FreeBSD 12.  The
>> previous kevent() system call in FreeBSD 12 kernels is now called
>> freebsd11_kevent() and is still used by older binaries compiled
>> against the older ABI.  The freebsd11_kevent() system call can be
>> tagged with an "alias" attribute of "kevent" permitting 'catch syscall
>> kevent' to catch both system calls and providing the expected user
>> behavior for both old and new binaries.  It also provides the expected
>> behavior if GDB is compiled on an older host (such as a FreeBSD 11
>> host).
> 
> Will we ever need to provide more than one alias to a syscall?

Sorry, I just saw you have already answered this question, here:

https://sourceware.org/ml/gdb-patches/2018-10/msg00385.html

Simon

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
  2018-11-09  4:34   ` Kevin Buettner
  2018-11-09 15:28   ` Simon Marchi
@ 2018-11-09 16:31   ` Pedro Alves
  2018-11-09 16:52     ` John Baldwin
  2 siblings, 1 reply; 15+ messages in thread
From: Pedro Alves @ 2018-11-09 16:31 UTC (permalink / raw)
  To: John Baldwin, gdb-patches

Hi,

On 11/06/2018 05:54 PM, John Baldwin wrote:

> --- a/gdb/syscalls/gdb-syscalls.dtd
> +++ b/gdb/syscalls/gdb-syscalls.dtd
> @@ -12,4 +12,5 @@
>  <!ATTLIST syscall
>  	name			CDATA	#REQUIRED
>  	number			CDATA	#REQUIRED
> +	alias			CDATA	#IMPLIED
>  	groups			CDATA	#IMPLIED>

I think there should be a NEWS entry for this.

I'd think there should be a docs update as well, but it
looks like this dtd isn't documented in the manual.  :-/


> +	  /* We have a name.  Let's check if it's valid and fetch a
> +	     list of matching numbers.  */
> +	  std::vector<int> numbers = get_syscalls_by_name (gdbarch, cur_name);
>  
> -	  if (s.number == UNKNOWN_SYSCALL)
> +	  if (numbers.empty ())
>  	    /* Here we have to issue an error instead of a warning,
>  	       because GDB cannot do anything useful if there's no
>  	       syscall number to be caught.  */
>  	    error (_("Unknown syscall name '%s'."), cur_name);
>  
>  	  /* Ok, it's valid.  */
> -	  result.push_back (s.number);
> +	  for (int number : numbers)
> +	    result.push_back (number);

Nit: this return-vector interface seems like leads to a bit of unnecessary
work, and double the number of necessary vector/heap allocations -- if
get_syscalls_by_name were passed RESULT instead of returning a new vector,
it could add to RESULT directly?  The code above would like something like this
instead with get_syscalls_by_name returning true/false to indicate
whether something was added:

	  /* We have a name.  Let's check if it's valid and fetch a
	     list of matching numbers.  */
	  if (!get_syscalls_by_name (gdbarch, cur_name, result))
 	    /* Here we have to issue an error instead of a warning,
	       because GDB cannot do anything useful if there's no
	       syscall number to be caught.  */
  	    error (_("Unknown syscall name '%s'."), cur_name);

That means there's no need to copy numbers between the vectors
(since there's only one vector).

Same for get_syscalls_by_group.

Note that instead of:

> +	  for (int number : numbers)
> +	    result.push_back (number);

You could write:

  result.insert (result.end (), numbers.begin (), numbers.end ());

which may be more efficient assuming insert is smart enough
to call std::vector::reserve to allocate space in one go.

Thanks,
Pedro Alves

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0.
  2018-11-06 17:56 ` [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0 John Baldwin
  2018-11-09  4:38   ` Kevin Buettner
@ 2018-11-09 16:34   ` Pedro Alves
  2018-11-09 17:36     ` John Baldwin
  1 sibling, 1 reply; 15+ messages in thread
From: Pedro Alves @ 2018-11-09 16:34 UTC (permalink / raw)
  To: John Baldwin, gdb-patches

On 11/06/2018 05:54 PM, John Baldwin wrote:
> Add a script to generate the FreeBSD XML system call table from the
> sys/sys/syscall.h file in the kernel source tree.  For ABI
> compatiblity system calls used by older binaries (such as
> freebsd11_kevent()), the original system call name is used as an
> alias.
> 
> Run this script against the current syscall.h file in FreeBSD's head
> branch which is expected to be the file used in 12.0 (head is
> currently in code freeze as part of the 12.0 release process).
> 
> gdb/ChangeLog:
> 
> 	* syscalls/update-freebsd.sh: New file.
> 	* syscalls/freebsd.xml: Regenerate.

Can you make the script emit the usual make-read-only trick at the
top of the generated file?  

See e.g., gdbarch.sh:

 /* *INDENT-OFF* */ /* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */
 /* vi:set ro: */

or make-target-delegates:

 print "/* THIS FILE IS GENERATED -*- buffer-read-only: t -*- */\n";
 print "/* vi:set ro: */\n\n";

> +++ b/gdb/syscalls/update-freebsd.sh
> @@ -0,0 +1,77 @@
> +#! /bin/sh
> +
> +# Copyright (C) 2011-2018 Free Software Foundation, Inc.

Curious, you had this script since 2011?

Thanks,
Pedro Alves

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries.
  2018-11-09 16:31   ` Pedro Alves
@ 2018-11-09 16:52     ` John Baldwin
  0 siblings, 0 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-09 16:52 UTC (permalink / raw)
  To: Pedro Alves, gdb-patches

On 11/9/18 8:31 AM, Pedro Alves wrote:
> Hi,
> 
> On 11/06/2018 05:54 PM, John Baldwin wrote:
> 
>> --- a/gdb/syscalls/gdb-syscalls.dtd
>> +++ b/gdb/syscalls/gdb-syscalls.dtd
>> @@ -12,4 +12,5 @@
>>  <!ATTLIST syscall
>>  	name			CDATA	#REQUIRED
>>  	number			CDATA	#REQUIRED
>> +	alias			CDATA	#IMPLIED
>>  	groups			CDATA	#IMPLIED>
> 
> I think there should be a NEWS entry for this.

Ok.

> I'd think there should be a docs update as well, but it
> looks like this dtd isn't documented in the manual.  :-/
> 
> 
>> +	  /* We have a name.  Let's check if it's valid and fetch a
>> +	     list of matching numbers.  */
>> +	  std::vector<int> numbers = get_syscalls_by_name (gdbarch, cur_name);
>>  
>> -	  if (s.number == UNKNOWN_SYSCALL)
>> +	  if (numbers.empty ())
>>  	    /* Here we have to issue an error instead of a warning,
>>  	       because GDB cannot do anything useful if there's no
>>  	       syscall number to be caught.  */
>>  	    error (_("Unknown syscall name '%s'."), cur_name);
>>  
>>  	  /* Ok, it's valid.  */
>> -	  result.push_back (s.number);
>> +	  for (int number : numbers)
>> +	    result.push_back (number);
> 
> Nit: this return-vector interface seems like leads to a bit of unnecessary
> work, and double the number of necessary vector/heap allocations -- if
> get_syscalls_by_name were passed RESULT instead of returning a new vector,
> it could add to RESULT directly?  The code above would like something like this
> instead with get_syscalls_by_name returning true/false to indicate
> whether something was added:
> 
> 	  /* We have a name.  Let's check if it's valid and fetch a
> 	     list of matching numbers.  */
> 	  if (!get_syscalls_by_name (gdbarch, cur_name, result))
>  	    /* Here we have to issue an error instead of a warning,
> 	       because GDB cannot do anything useful if there's no
> 	       syscall number to be caught.  */
>   	    error (_("Unknown syscall name '%s'."), cur_name);
> 
> That means there's no need to copy numbers between the vectors
> (since there's only one vector).
> 
> Same for get_syscalls_by_group.

Oh, yes, that is a much better idea.  I will adopt that change in both
patches.

> Note that instead of:
> 
>> +	  for (int number : numbers)
>> +	    result.push_back (number);
> 
> You could write:
> 
>   result.insert (result.end (), numbers.begin (), numbers.end ());
> 
> which may be more efficient assuming insert is smart enough
> to call std::vector::reserve to allocate space in one go.

Ok.  I wasn't quite sure if there was a more efficient idiom to use.  It's
a bit of a shame std::vector<> doesn't have an explicit append/join method
similar to list.append() in Python.

-- 
John Baldwin

                                                                            

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0.
  2018-11-09 16:34   ` Pedro Alves
@ 2018-11-09 17:36     ` John Baldwin
  0 siblings, 0 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-09 17:36 UTC (permalink / raw)
  To: Pedro Alves, gdb-patches

On 11/9/18 8:34 AM, Pedro Alves wrote:
> On 11/06/2018 05:54 PM, John Baldwin wrote:
>> Add a script to generate the FreeBSD XML system call table from the
>> sys/sys/syscall.h file in the kernel source tree.  For ABI
>> compatiblity system calls used by older binaries (such as
>> freebsd11_kevent()), the original system call name is used as an
>> alias.
>>
>> Run this script against the current syscall.h file in FreeBSD's head
>> branch which is expected to be the file used in 12.0 (head is
>> currently in code freeze as part of the 12.0 release process).
>>
>> gdb/ChangeLog:
>>
>> 	* syscalls/update-freebsd.sh: New file.
>> 	* syscalls/freebsd.xml: Regenerate.
> 
> Can you make the script emit the usual make-read-only trick at the
> top of the generated file?

I ended up having to do it in a kind of ugly way to get a file that
libexpat would parse and Emacs would still recognize as read-only.

This version libexpat failed to parse:

<!-- THIS FILE IS GENERATED -*- buffer-read-only: t -*-  -->
<!-- vi:set ro: -->
<?xml version="1.0"?>

This version Emacs didn't mark read-only:

<?xml version="1.0"?>
<!-- THIS FILE IS GENERATED -*- buffer-read-only: t -*-  -->
<!-- vi:set ro: -->

So I'm using this:

<?xml version="1.0"?> <!-- THIS FILE IS GENERATED -*- buffer-read-only: t -*-  -->
<!-- vi:set ro: -->

I haven't tested in vim though.

>> +++ b/gdb/syscalls/update-freebsd.sh
>> @@ -0,0 +1,77 @@
>> +#! /bin/sh
>> +
>> +# Copyright (C) 2011-2018 Free Software Foundation, Inc.
> 
> Curious, you had this script since 2011?

Oops, I just copied the license block from update-gnulib.sh I think.  Fixed.

-- 
John Baldwin

                                                                            

^ permalink raw reply	[flat|nested] 15+ messages in thread

* Re: [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group.
  2018-11-09  4:27   ` Kevin Buettner
@ 2018-11-09 17:55     ` John Baldwin
  0 siblings, 0 replies; 15+ messages in thread
From: John Baldwin @ 2018-11-09 17:55 UTC (permalink / raw)
  To: Kevin Buettner, gdb-patches

On 11/8/18 8:27 PM, Kevin Buettner wrote:
> On Tue,  6 Nov 2018 09:54:29 -0800
> John Baldwin <jhb@FreeBSD.org> wrote:
> 
>> This removes the need for the caller to explicitly manage the memory
>> for the returned system call list.  This change only returns the
>> numbers rather than a vector of syscall structures since the caller
>> only needs the numbers.
>>
>> gdb/ChangeLog:
>>
>> 	* break-catch-syscall.c (catch_syscall_split_args): Update for
>> 	get_syscalls_by_group returning a vector.
>> 	* xml-syscall.c [!HAVE_LIBEXPATH] (get_syscalls_by_group): Return
> 
> s/HAVE_LIBEXPATH/HAVE_LIBEXPAT/

Thanks, will be fixed in v3.

-- 
John Baldwin

                                                                            

^ permalink raw reply	[flat|nested] 15+ messages in thread

end of thread, other threads:[~2018-11-09 17:55 UTC | newest]

Thread overview: 15+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2018-11-06 17:56 [PATCH v2 0/3] Update FreeBSD's syscall table John Baldwin
2018-11-06 17:56 ` [PATCH v2 1/3] Return a vector of integers from get_syscalls_by_group John Baldwin
2018-11-09  4:27   ` Kevin Buettner
2018-11-09 17:55     ` John Baldwin
2018-11-06 17:56 ` [PATCH v2 2/3] Add an optional "alias" attribute to syscall entries John Baldwin
2018-11-09  4:34   ` Kevin Buettner
2018-11-09 15:28   ` Simon Marchi
2018-11-09 15:36     ` Simon Marchi
2018-11-09 16:31   ` Pedro Alves
2018-11-09 16:52     ` John Baldwin
2018-11-06 17:56 ` [PATCH v2 3/3] Update the FreeBSD system call table to match FreeBSD 12.0 John Baldwin
2018-11-09  4:38   ` Kevin Buettner
2018-11-09 16:34   ` Pedro Alves
2018-11-09 17:36     ` John Baldwin
2018-11-06 18:49 ` [PATCH v2 0/3] Update FreeBSD's syscall table Sergio Durigan Junior

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).